unit Delphi6Exercise;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ExtDlgs, Buttons, Menus, ImgList, Math;

type
  T2Dinteger = array of array of integer;

  TDLA = class(TForm)
    Image1: TImage;
    Image2: TImage;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Options1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    SaveAs1: TMenuItem;
    Exit1: TMenuItem;
    NumPoints1: TMenuItem;
    SavePictureDialog1: TSavePictureDialog;
    ImageList1: TImageList;
    Reset1: TMenuItem;
    Image3: TImage;
    Plantlife1: TMenuItem;
    Snowflake1: TMenuItem;
    N2: TMenuItem;
    oLimit1: TMenuItem;
    N3: TMenuItem;
    ImageSize1: TMenuItem;
    N1: TMenuItem;
    START1: TMenuItem;
    Cancel1: TMenuItem;
    function Globe(X : integer) : integer;

    procedure Exit1Click(Sender: TObject);
    procedure NumPoints1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure Plantlife1Click(Sender: TObject);
    procedure Snowflake1Click(Sender: TObject);
    procedure DoPlantlife;
    procedure DoSnowflake;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure oLimit1Click(Sender: TObject);
    procedure ImageSize1Click(Sender: TObject);
    procedure START1Click(Sender: TObject);
    procedure Cancel1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DLA: TDLA;
  PointsDone : Integer;
  MaxHeight : integer;
  MaxRadius : integer;
  CancelDown : boolean;
  PictureP : boolean;
  PictureS : boolean;
  PlantSize : TPoint;
  SnowSize : TPoint;

implementation

uses DLAnum, AboutDLAunit, SaveUnit, SizeUnit;

{$R *.dfm}

function TDLA.Globe(X : integer) : integer;
begin
 Result := X;
 if X = 0 then Result := PlantSize.X - 1;
 if X = PlantSize.X then Result := 1;
end;

procedure TDLA.START1Click(Sender: TObject);
begin
 if Plantlife1.Checked then begin DoPlantlife; PictureP := True; end;
 if Snowflake1.Checked then begin DoSnowflake; PictureS := True; end;
end; {begin}

// Close program
procedure TDLA.Exit1Click(Sender: TObject);
begin
 Close;
end;

// Stop processing
procedure TDLA.Cancel1Click(Sender: TObject);
begin
 CancelDown := True;
 START1.Enabled := True;
 Cancel1.Enabled := False;
end;

// View number of points form
procedure TDLA.NumPoints1Click(Sender: TObject);
begin
 Form1.Visible := True;
end;

procedure TDLA.FormCreate(Sender: TObject);
Var
 x, y : integer;
begin
 MaxHeight := 295;
 MaxRadius := 1;
 CancelDown := False;
 PictureP := False;
 PictureS := False;
 PlantSize.X := 150;
 PlantSize.Y := 300;
 SnowSize.X := 300;
 SnowSize.Y := 300;
 Randomize;
end;

// Save image as bitmap
procedure TDLA.SaveAs1Click(Sender: TObject);
begin
SavePictureDialog1.Execute;
if Plantlife1.Checked then begin
 if SavePictureDialog1.FileName[length(SavePictureDialog1.FileName)-3] = '.' then
  Image1.Picture.Bitmap.SaveToFile(SavePictureDialog1.FileName)
 else
  Image1.Picture.Bitmap.SaveToFile(SavePictureDialog1.FileName + '.bmp');
 PictureP := False;
end;
if Snowflake1.Checked then begin
 if SavePictureDialog1.FileName[length(SavePictureDialog1.FileName)-3] = '.' then
  Image3.Picture.Bitmap.SaveToFile(SavePictureDialog1.FileName)
 else
  Image3.Picture.Bitmap.SaveToFile(SavePictureDialog1.FileName + '.bmp');
 PictureS := False;
end;

end;

// View about box
procedure TDLA.About1Click(Sender: TObject);
begin
 AboutDLA.Visible := True;
end;

procedure TDLA.Reset1Click(Sender: TObject);
Var
 x, y : integer;
begin
if Plantlife1.Checked then begin
 Image1.Picture.Bitmap.Width := PlantSize.X;
 Image1.Picture.Bitmap.Height := PlantSize.Y;
 for y := PlantSize.Y - 6 downto 0 do for x := 0 to PlantSize.X do
  if Image1.Canvas.Pixels[x,y] <> clblack then
   Image1.Canvas.Pixels[x,y] := clblack;
 if PlantSize.Y < 300 then for y := PlantSize.Y - 5 to PlantSize.Y do
  for x := 0 to PlantSize.X do Image1.Canvas.Pixels[x,y] := clwhite;
 MaxHeight := PlantSize.Y - 5;
 PictureP := False;
end;
if Snowflake1.Checked then begin
 Image3.Picture.Bitmap.Width := SnowSize.X;
 Image3.Picture.Bitmap.Height := SnowSize.Y;
 for y := 0 to SnowSize.Y do for x := 0 to SnowSize.X do
  if Image3.Canvas.Pixels[x,y] <> clblack then
   Image3.Canvas.Pixels[x,y] := clblack;
 Image3.Canvas.Pixels[Round(SnowSize.X / 2), Round(SnowSize.Y / 2)] := clwhite;
 MaxRadius := 1;
 PictureS := False;
end;
end;

procedure TDLA.Plantlife1Click(Sender: TObject);
begin
Plantlife1.Checked := True;
Snowflake1.Checked := False;
Image1.Visible := True;
Image3.Visible := False;
Form1.SpinEdit1.MaxValue := 8000;
SizeForm.SpinEdit1.Value := PlantSize.X;
SizeForm.SpinEdit2.Value := PlantSize.Y;
end;

procedure TDLA.Snowflake1Click(Sender: TObject);
begin
Snowflake1.Checked := True;
Plantlife1.Checked := False;
Image3.Visible := True;
Image1.Visible := False;
Form1.SpinEdit1.MaxValue := 7000;
SizeForm.SpinEdit1.Value := SnowSize.X;
SizeForm.SpinEdit2.Value := SnowSize.Y;
end;

procedure TDLA.DoPlantlife;
Var
 XPos, YPos, Direction, x, y : integer;
 Dest, Sour : TRect;
 rep : integer;
 NumPoints : integer;
 ToLimit : boolean;
 //JumpSize : integer;
begin
 Cancel1.Enabled := True;
 START1.Enabled := False;
 ToLimit := oLimit1.Checked;
 MaxHeight := PlantSize.Y - 5;
 if ToLimit then NumPoints := 10000000 else
  NumPoints := Form1.SpinEdit1.Value;

for rep := 0 to NumPoints do begin

 if CancelDown then begin
  CancelDown := False;
  Exit;
 end;
 XPos := random(PlantSize.X);
 YPos := MaxHeight - 10;
 while (Image1.Canvas.Pixels[Globe(XPos+1), YPos] <> clwhite)
   AND (Image1.Canvas.Pixels[Globe(XPos-1), YPos] <> clwhite)
   AND (Image1.Canvas.Pixels[XPos, YPos+1] <> clwhite)
   AND (Image1.Canvas.Pixels[XPos, YPos-1] <> clwhite)
   AND (Image1.Canvas.Pixels[Globe(XPos+1), YPos+1] <> clwhite)
   AND (Image1.Canvas.Pixels[Globe(XPos-1), YPos+1] <> clwhite)
   AND (Image1.Canvas.Pixels[Globe(XPos+1), YPos-1] <> clwhite)
   AND (Image1.Canvas.Pixels[Globe(XPos-1), YPos-1] <> clwhite) do begin
  Direction := trunc(random(7))+1;

  //JumpSize := 1000000;
  //for y := MaxHeight to PlantSize.Y - 4 do
   //for x := 0 to PlantSize.X do
    //if (Image1.Canvas.Pixels[x,y] = clwhite)AND
       //(Sqrt(Sqr(Abs(XPos-x))+Sqr(Abs(YPos-y))) < JumpSize) then
     //JumpSize := Round(Sqrt(Sqr(Abs(XPos-x))+Sqr(Abs(YPos-y))))-2;
  //if JumpSize < 1 then JumpSize := 1;

  Case Direction of
   1 : inc(Xpos{,JumpSize});
   2 : dec(XPos{,JumpSize});
   3 : inc(YPos{,JumpSize});
   {4 : dec(Ypos,JumpSize);} // disabled to give net motion downwards
   4 : begin inc(XPos{,JumpSize}); inc(YPos{,JumpSize}); end;
   5 : begin inc(XPos{,JumpSize}); dec(YPos{,JumpSize}); end;
   6 : begin dec(XPos{,JumpSize}); inc(YPos{,JumpSize}); end;
   7 : begin dec(XPos{,JumpSize}); dec(YPos{,JumpSize}); end;
  end; {case}
  if XPos = 0 then XPos := PlantSize.X - 1;
  if XPos = PlantSize.X then XPos := 1;
  if YPos < MaxHeight-30 then YPos := MaxHeight-10;
 end; {while}
 if (rep/30) = Trunc(rep/30) then Application.ProcessMessages;
 Dest := Rect(XPos, YPos, XPos+1, YPos+1);
 Sour := Rect(0, 0, 1, 1);
 Image1.Canvas.CopyRect(Dest, Image2.Canvas, Sour);
 //Image1.Canvas.Pixels[XPos,YPos] := clwhite;
 if YPos < MaxHeight then MaxHeight := YPos;
 if ToLimit and (MaxHeight < 2) then break;
end;
START1.Enabled := True;
Cancel1.Enabled := False;
end;

procedure TDLA.DoSnowflake;
Var
 XPos, YPos, Direction, x, y : integer;
 Dest, Sour : TRect;
 rep : integer;
 NumPoints : integer;
 Angle : real;
 ToLimit : boolean;
begin
 Cancel1.Enabled := True;
 START1.Enabled := False;
 ToLimit := oLimit1.Checked;
 if ToLimit then NumPoints := 10000000 else
  NumPoints := Form1.SpinEdit1.Value;
for rep := 0 to NumPoints do begin

 if CancelDown then begin
  CancelDown := False;
  Exit;
 end;
 Angle := 2*pi*Random;
 XPos := Round(SnowSize.X / 2) + Round((MaxRadius + 5)*Cos(Angle));
 YPos := Round(SnowSize.Y / 2) + Round((MaxRadius + 5)*Sin(Angle));
 while (Image3.Canvas.Pixels[XPos+1, YPos  ] <> clwhite)
   AND (Image3.Canvas.Pixels[XPos-1, YPos  ] <> clwhite)
   AND (Image3.Canvas.Pixels[XPos  , YPos+1] <> clwhite)
   AND (Image3.Canvas.Pixels[XPos  , YPos-1] <> clwhite)
   AND (Image3.Canvas.Pixels[XPos+1, YPos+1] <> clwhite)
   AND (Image3.Canvas.Pixels[XPos-1, YPos+1] <> clwhite)
   AND (Image3.Canvas.Pixels[XPos+1, YPos-1] <> clwhite)
   AND (Image3.Canvas.Pixels[XPos-1, YPos-1] <> clwhite) do begin
  Direction := trunc(random(8))+1;
  Case Direction of
   1 : dec(Xpos);
   2 : begin dec(XPos); inc(YPos); end;
   3 : inc(YPos);
   4 : begin inc(XPos); inc(YPos); end;
   5 : inc(XPos);
   6 : begin inc(XPos); dec(YPos); end;
   7 : dec(Ypos);
   8 : begin dec(XPos); dec(YPos); end;
  end; {case}

  if Round(Sqrt(Sqr(YPos-(SnowSize.Y / 2)) + Sqr(XPos-(SnowSize.X / 2)))) >
                                                 MaxRadius + 8 then begin
   XPos := Round(SnowSize.X / 2) + Round((MaxRadius + 5)*Cos(Angle));
   YPos := Round(SnowSize.Y / 2) + Round((MaxRadius + 5)*Sin(Angle));
  end;

 end; {while}

 if rep/(Round(MaxRadius/5)+1) = Trunc(rep/(Round(MaxRadius/5)+1)) then
  Application.ProcessMessages;
 Dest := Rect(XPos, YPos, XPos+1, YPos+1);
 Sour := Rect(0, 0, 1, 1);
 Image3.Canvas.CopyRect(Dest, Image2.Canvas, Sour);
 //Image3.Canvas.Pixels[XPos,YPos] := clwhite;
 if Round(Sqrt(Sqr(YPos-(SnowSize.Y / 2)) + Sqr(XPos-(SnowSize.X / 2)))) > MaxRadius then
  MaxRadius := Round(Sqrt(Sqr(YPos-(SnowSize.Y / 2)) + Sqr(XPos-(SnowSize.X / 2))));
 if ToLimit and (MaxRadius > (Min(SnowSize.X, SnowSize.Y) / 2) - 2) then break;
end;
START1.Enabled := True;
Cancel1.Enabled := False;
end;

procedure TDLA.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if (PlantLife1.Checked AND PictureP)OR(SnowFlake1.Checked AND PictureS) then
 if Save.ShowModal = MrYes then SaveAs1Click(sender);
end;

procedure TDLA.oLimit1Click(Sender: TObject);
begin
 oLimit1.Checked := not oLimit1.Checked;
 if oLimit1.Checked then NumPoints1.Enabled := False
 else NumPoints1.Enabled := True;
end;

procedure TDLA.ImageSize1Click(Sender: TObject);
begin
 SizeForm.Visible := True;
end;

end.
